package graph;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

//TODO: realize graph using adjacency matrix
//


public class Graph<VertexHeader> extends GraphCore{ 		
	//getVertexHeaderCode() method requires VertexHeader.hashCode() to be defined!
	//toString() method requires VertexHeader.toString() to be defined!
	
	private HashMap<VertexHeader, Integer> VertexHeaderMap = new HashMap<VertexHeader, Integer>();
	
	public Graph(int directionParameter){
		super(directionParameter);
	}
	
	private boolean addVertex(VertexHeader vertexFrom){
		addVertexHeader(vertexFrom);
		return super.addVertex(findVertexCode(vertexFrom));
	}
	
	private boolean deleteVertex(VertexHeader vertexFrom){
		boolean warningExist = super.isVertexExist(findVertexCode(vertexFrom));
		super.deleteVertex(findVertexCode(vertexFrom));
		deleteVertexHeader(vertexFrom);
		
		return warningExist;
	}
	
	public boolean addEdge(VertexHeader vertexFrom, VertexHeader vertexTo, int weight){
		if (!isVertexExist(vertexFrom)) addVertex(vertexFrom);
		if (!isVertexExist(vertexTo)) addVertex(vertexTo);
		
		return super.addEdge(findVertexCode(vertexFrom), findVertexCode(vertexTo), weight);
	}	
	
	public boolean deleteEdge(VertexHeader vertexFrom, VertexHeader vertexTo){
		if (!isVertexExist(vertexFrom)) return false;
		if (!isVertexExist(vertexTo)) return false;
		
		boolean warningExist = super.deleteEdge(findVertexCode(vertexFrom), findVertexCode(vertexTo));
		if (!super.isVertexExist(findVertexCode(vertexFrom))) deleteVertexHeader(vertexFrom);
		if (!super.isVertexExist(findVertexCode(vertexTo))) deleteVertexHeader(vertexTo);
		
		return warningExist;
	}
	
	private boolean isVertexExist(VertexHeader vertexFrom){
		if (!VertexHeaderMap.containsKey(vertexFrom)) return false;
		
		return super.isVertexExist(findVertexCode(vertexFrom));
	}
	
	public int getEdgeWeight(VertexHeader vertexFrom, VertexHeader vertexTo){
		return super.getEdgeWeight(findVertexCode(vertexFrom), findVertexCode(vertexTo));
	}
	
	public boolean isEdgeExist(VertexHeader vertexFrom, VertexHeader vertexTo){
		return super.isEdgeExist(findVertexCode(vertexFrom), findVertexCode(vertexTo));
	}

	protected int findVertexCode(VertexHeader vertexFrom){
		return VertexHeaderMap.get(vertexFrom);		//TODO: no such vertex exception
	}
	
	private int calculateVertexHeaderCode(VertexHeader vertexFrom){
		return vertexFrom.hashCode();
	}
	
	private void addVertexHeader(VertexHeader vertexFrom){
		VertexHeaderMap.put(vertexFrom, calculateVertexHeaderCode(vertexFrom));
	}
	
	private void deleteVertexHeader(VertexHeader vertexFrom){
		VertexHeaderMap.remove(vertexFrom);
	}
	
	public boolean isEmpty(){
		return super.isEmpty();
	}
	
	public ArrayList<EdgeLight> getEdgeList(VertexHeader vertexFrom){	
		if (!isVertexExist(vertexFrom)) return null;
		
		return super.getEdgeList(findVertexCode(vertexFrom));
	}

	protected ArrayList<Integer> getVertexList(){
		ArrayList<Integer> tempList = new ArrayList<Integer>();
		
//		for (Entry<VertexHeader, Integer> entry : VertexHeaderMap.entrySet()) {
//		    VertexHeader key = entry.getKey();
//		    Object value = entry.getValue();
//		}
		
		for (Integer value : VertexHeaderMap.values()) {
			tempList.add(value);
		}
		
		return tempList;
	}
	
	protected ArrayList<EdgeLight> getEdgeList(int vertexFrom){	
		if (!isVertexExist(vertexFrom)) return null;
		
		return super.getEdgeList(vertexFrom);
	}
	
	public String toString(){
		if (isEmpty()) return "{empty}\n";
		
		String outString = "";
		
		outString += VertexHeaderMap.toString() + "\n";
		outString += super.toString() + "\n";
		
		return outString;
	}
}
