package graph;

import java.util.ArrayList;
//TODO: realize graph using adjacency matrix FOR THE GREAT JUSTICE

public class GraphCore{ 
	
	public static int BIDIRECTIONAL = 12301;		//TODO: just can't watch this
	public static int UNDIRECTIONAL = 53432;
	private int direction;
	
	private ArrayList<VertexLight> Vertexes = new ArrayList<VertexLight>();
	
	protected GraphCore(int directionParameter){		
		if ((directionParameter != UNDIRECTIONAL)&&(directionParameter != BIDIRECTIONAL)){
			System.out.println("u failed");
			return;
		}
		else this.direction = directionParameter;
	}
	
	protected boolean addVertex(int vertexFrom){
		if (isVertexExist(vertexFrom)) return false;
		
		Vertexes.add(new VertexLight(vertexFrom));
		return true;
	}
	
	protected boolean deleteVertex(int vertexFrom){
		if (!isVertexExist(vertexFrom)) return false;
		
		Vertexes.remove(findVertex(vertexFrom));
		return true;
	}
	
	protected int getEdgeWeight(int vertexFrom, int vertexTo){
		if (!isVertexExist(vertexFrom)) return -1;
		if (!isVertexExist(vertexTo)) return -1;
		if (!isEdgeExist(vertexFrom, vertexTo)) return -1;
		
		return findVertex(vertexFrom).getEdge(vertexTo).getWeight();
	}
	
	protected boolean addEdge(int vertexFrom, int vertexTo, int weight){
		if (this.direction == UNDIRECTIONAL)
			return (addEdge_(vertexFrom, vertexTo, weight) & addEdge_(vertexTo, vertexFrom, weight));
		else
			return (addEdge_(vertexFrom, vertexTo, weight));
	}	
	
	private boolean addEdge_(int vertexFrom, int vertexTo, int weight){
		if (!isVertexExist(vertexFrom)) addVertex(vertexFrom);						//no such vertex
		if (!findVertex(vertexFrom).addEdge(vertexTo, weight)) 
			return false;		//already exists warning
		else
			return true;
	}	
	
	protected boolean deleteEdge(int vertexFrom, int vertexTo){
		if (this.direction == UNDIRECTIONAL)
			return (deleteEdge_(vertexFrom, vertexTo) & deleteEdge_(vertexTo, vertexFrom));
		else
			return (deleteEdge_(vertexFrom, vertexTo));
	}
	
	private boolean deleteEdge_(int vertexFrom, int vertexTo){
		if (!isVertexExist(vertexFrom)) return false;
		if (findVertex(vertexFrom).deleteEdge(vertexTo)){
			if (findVertex(vertexFrom).isEmpty())
				return deleteVertex(vertexFrom);
			return true;
		}
		else 
			return false;
	}
	
	protected boolean isVertexExist(int vertexFrom){
		return (findVertex(vertexFrom) != null);
	}
	
	protected boolean isEdgeExist(int vertexFrom, int vertexTo){
		if (!isVertexExist(vertexFrom)) return false;
		if (!isVertexExist(vertexTo)) return false;
		
		return findVertex(vertexFrom).isEdgeExist(vertexTo);
	}

	private VertexLight findVertex(int vertexFrom){			//null - vertex doesn't exist
		if (Vertexes == null) return null;
		
		for (VertexLight tempVertex : Vertexes){
			if (tempVertex.getVertexName() == vertexFrom)
				return tempVertex;
		}
		
		return null;
	}
	
	protected boolean isEmpty(){
		return Vertexes.isEmpty();
	}
	
	protected ArrayList<EdgeLight> getEdgeList(int vertexFrom){	
		return findVertex(vertexFrom).getEdgeList();
	}
	
	public String toString(){
		String outString = "";
		
		for (VertexLight tempVertex : Vertexes){
			outString += tempVertex.toString();
		}
		
		return outString;
	}
}
