package graph;

import java.util.ArrayList;

public class VertexLight{
	private ArrayList<EdgeLight> Edges = new ArrayList<EdgeLight> ();
	private int vertexName;
	
	public VertexLight(int vertexName){
		this.vertexName = vertexName;
	}
	
	public int getVertexName(){
		return vertexName;
	}
	
	public boolean addEdge(int vertexTo, int weight){
		if (isEdgeExist(vertexTo)) return false;		//already exists warning
		
		Edges.add(new EdgeLight(vertexTo, weight));
		return true;
	}
	
	public boolean deleteEdge(int vertexTo){
		if (!isEdgeExist(vertexTo)){
			return false;
		}
				
		Edges.remove(findLightEdge(vertexTo));
		
		return true;
	}
	
	public Edge getEdge (int vertexTo){
		
		return findLightEdge(vertexTo).getEdge(this.vertexName);
	}

	public boolean isEdgeExist(int vertexTo){
		return (findLightEdge(vertexTo) != null);
	}

	public boolean isEmpty(){
		return Edges.isEmpty();
	}
	
	private EdgeLight findLightEdge(int vertexTo){		
		if (Edges == null) return null;
		
		for (EdgeLight tempEdge : Edges){
			if (tempEdge.getTo() == vertexTo){
				
				return tempEdge;
			}
		}
		
		return null;
	}
	
	/*
	@SuppressWarnings("null")
	public ArrayList<Edge> getEdgeList(){
		ArrayList<Edge> tempList = null;
		
		for (EdgeLight tempLightEdge : Edges){
			tempList.add(tempLightEdge.getEdge(this.vertexName));
		}
		
		return tempList;
	}*/
	
	public ArrayList<EdgeLight> getEdgeList(){
		return Edges;
	}
	
	public String toString(){
		String outString = "";
		
		outString += "{{" + vertexName + "}\n";
		
		if (!isEmpty()){
			for (EdgeLight tempEdge : Edges){
				outString += "	{" + tempEdge.toString() + "}\n";
			}
		}

		outString += "}\n";
		
		return outString;
	}
}
