package graph;


import java.util.HashMap;
import java.util.LinkedList;

public class _Dijkstra<VertexHeader>{

	private LinkedList<Integer> vertexQueue = new LinkedList<Integer>();
	private Graph<VertexHeader> myGraph;
	
	private static final int UNDEFINEDWAY = -1;
	private static final int UNDEFINEDVERTEX = -1;
	
	
	public _Dijkstra (Graph<VertexHeader> myGraph){
		this.myGraph = myGraph;
	}
	
	public int getShortestWay(VertexHeader startVertex, VertexHeader finishVertex){
		int startVertexCode = myGraph.findVertexCode(startVertex);
		
		HashMap<Integer, Boolean> usedVertexes = new HashMap<Integer, Boolean>();
		HashMap<Integer, Integer> shortestWays = new HashMap<Integer, Integer>();

		vertexQueue.add(startVertexCode);
		
		for (int tempVertex : myGraph.getVertexList()){
			shortestWays.put(tempVertex, UNDEFINEDWAY);
			usedVertexes.put(tempVertex, false);
		}

		shortestWays.put(startVertexCode, 0);
		
		int currentVertexFromCode, currentVertexToCode;
		int minimumWayValue, minimumWayVertex;
		while (!vertexQueue.isEmpty()){
			currentVertexFromCode = vertexQueue.poll();
			minimumWayValue = UNDEFINEDWAY;
			minimumWayVertex = UNDEFINEDVERTEX;
			usedVertexes.put(currentVertexFromCode, true);
			
			for (EdgeLight currentVertexTo : myGraph.getEdgeList(currentVertexFromCode)){
				currentVertexToCode = currentVertexTo.getTo();
				
				if (!usedVertexes.get(currentVertexToCode)){
					if ((shortestWays.get(currentVertexToCode)>shortestWays.get(currentVertexFromCode)+myGraph.getEdgeWeight(currentVertexFromCode, currentVertexToCode)
						||
						(shortestWays.get(currentVertexToCode) == UNDEFINEDWAY))){
						shortestWays.put(currentVertexToCode, shortestWays.get(currentVertexFromCode)+myGraph.getEdgeWeight(currentVertexFromCode, currentVertexToCode));
						if ((shortestWays.get(currentVertexToCode)< minimumWayValue)
							||
							(minimumWayValue == UNDEFINEDWAY)){
							minimumWayValue = shortestWays.get(currentVertexToCode);
							minimumWayVertex = currentVertexToCode;
						}
					}
				}
			}

			if (minimumWayVertex != UNDEFINEDVERTEX){
				vertexQueue.add(minimumWayVertex);
			}
		}
		
		return shortestWays.get(myGraph.findVertexCode(finishVertex));	
	}
}
