package test;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import graph._Dijkstra;
import graph.Graph;

public class Test {

	public static void main(String[] args) throws NumberFormatException, IOException {

		Graph<String> myGraph = new Graph<String>(Graph.UNDIRECTIONAL);
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		System.out.println("system console input");
		System.out.println("empty line to finish input");
		readGraph(myGraph,new BufferedReader(new InputStreamReader(System.in)));
		
//		System.out.println("1 - system console input\n2 - file input\nany other - default file input (input/input.txt)");	
//		
//		switch (Integer.parseInt(br.readLine())){
//		case 1:
//			System.out.println("system console input");
//			System.out.println("empty line to finish input");
//			readGraph(myGraph,new BufferedReader(new InputStreamReader(System.in)));
//			break;
//		case 2:
//			System.out.println("file input");
//			System.out.println("input filename");
//			
//			String filename = br.readLine();
//			
//			{
//				FileReader fileReader = new FileReader(filename);
//				
//				readGraph(myGraph,new BufferedReader(fileReader));
//				fileReader.close();
//			}
//			
//			break;
//		default:
//			System.out.println("default file input (input.txt)");
//			{
//				FileReader fileReader = new FileReader("input//input.txt");
//	
//				readGraph(myGraph,new BufferedReader(fileReader));
//				fileReader.close();
//			}
//			
//			break;
//		}
		
		System.out.println("type start and finish vertexes");
		String startVertex = br.readLine();
		String finishVertex = br.readLine();
		
		_Dijkstra<String> dijkstraAlgorithm = new _Dijkstra<String> (myGraph);
		
		System.out.println(dijkstraAlgorithm.getShortestWay(startVertex, finishVertex));
		
		//System.out.println(myGraph);
		
	}

	public static Graph<String> readGraph(Graph<String> myGraph, BufferedReader inputStream) throws IOException{
		
		String currentEdge;
		
		Pattern patternEdge = Pattern.compile("^(\\w*)[\\s;,]+(\\w*)[\\s;,]+(\\d*)$");
		Matcher matcherEdge;
		
		while (!(currentEdge = inputStream.readLine()).isEmpty()){
			matcherEdge = patternEdge.matcher(currentEdge);
			
			if (matcherEdge.matches()){
				myGraph.addEdge(matcherEdge.group(1), matcherEdge.group(2), Integer.parseInt(matcherEdge.group(3)));
			}
				
		}
		
		return null;
	}
}
